<template>
  <div class="app-container">
    <!-- 查询和其他操作 -->
    <div class="filter-container" style="margin: 10px 0 10px 0;">
      <el-form :inline="true" label-width="68px" style="margin-bottom: 8px;">
        <el-form-item label="项目">
          <el-select
            v-model="queryParams.source"
            class="filter-item"
            placeholder="项目"
            style="width: 140px"
            filterable
            clearable
            remote
            reserve-keyword
          >
            <el-option
              v-for="item in sourceData"
              :key="item.source"
              :label="item.name"
              :value="item.source"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="用户ID">
          <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.customerId" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="创建时间">
          <el-date-picker
            v-model="queryParams.beginCreateTime"
            type="date"
            placeholder="开始日期"
            class="baseInput"
            format="yyyy-MM-dd"
            value-format="yyyy-MM-dd"
            style="width: 200px;"
          >
          </el-date-picker>
          <span> - </span>
          <el-date-picker
            v-model="queryParams.endCreateTime"
            type="date"
            placeholder="结束日期"
            class="baseInput"
            format="yyyy-MM-dd"
            value-format="yyyy-MM-dd"
            style="width: 200px;"
          >
          </el-date-picker>
        </el-form-item>
        <el-form-item label="漫画名称">
          <el-input clearable class="filter-item" style="width: 200px;" v-model="queryParams.bookName" placeholder="请输入" />
        </el-form-item>
        <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFind">查询</el-button>
      </el-form>
    </div>

    <el-table :data="tableData" style="width:100%"
              @selection-change="handleSelectionChange"
              @sort-change="changeSort"
              :default-sort="{prop: 'sort', order: 'descending'}"
              class="show_table" >
      <el-table-column label="ID" width="80" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.uid }}</span>
        </template>
      </el-table-column>
      <el-table-column label="项目" width="180" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.sourceName }}</span>
        </template>
      </el-table-column>
      <el-table-column label="用户ID" width="270" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.customerId }}</span>
        </template>
      </el-table-column>
      <el-table-column label="漫画ID" width="80" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.bookId }}</span>
        </template>
      </el-table-column>
      <el-table-column label="漫画名称" width="250" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.bookName }}</span>
        </template>
      </el-table-column>
      <el-table-column label="目前观看集数ID" width="150" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.episode }}</span>
        </template>
      </el-table-column>
      <el-table-column label="话数名称" width="150" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.capterName }}</span>
        </template>
      </el-table-column>
      <el-table-column label="最近一次观看日期" width="180" align="center" prop="updateTime" sortable="custom" :sort-by="['updateTime']">
        <template slot-scope="scope">
          <span>{{ scope.row.updateTime.substring(0,10) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="创建时间" width="180" align="center" prop="createTime" sortable="custom" :sort-by="['createTime']">
        <template slot-scope="scope">
          <span>{{ scope.row.createTime }}</span>
        </template>
      </el-table-column>
    </el-table>

    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-sizes="[40, 80, 120, 200]"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>

  </div>
</template>

<script>
import {
  getReadingLogList,
  getSourceList,
} from "@/api/readinglog";

export default {
  data() {
    return {
      queryParams:{//查询参数
        customerId: "", //用户ID
        bookName: "", //漫画名称
        beginCreateTime: "", //创建时间-开始
        endCreateTime: "", //创建时间-结束
        source: "", //项目
      },
      multipleSelection: [], //多选，用于批量删除
      tableData: [],
      sourceData: [
        {
          name:'全部',
          source:''}
      ],
      currentPage: 1,
      pageSize: 40,
      total: 0, //总数量
      orderByDescColumn: "", // 降序字段
      orderByAscColumn: "", // 升序字段
    };
  },
  created() {
    this.readingLogList();
    this.sourceList();
  },
  methods: {
    // 从后台获取数据,重新排序
    changeSort (val) {
      // 根据当前排序重新获取后台数据,一般后台会需要一个排序的参数
      if(val.order == "ascending") {
        this.orderByAscColumn = val.prop
        this.orderByDescColumn = ""
      } else {
        this.orderByAscColumn = ""
        this.orderByDescColumn = val.prop
      }
      this.readingLogList()
    },
    readingLogList: function() {

      this.queryParams.currentPage = this.currentPage;
      this.queryParams.pageSize = this.pageSize;
      this.queryParams.orderByDescColumn = this.orderByDescColumn
      this.queryParams.orderByAscColumn = this.orderByAscColumn
      // console.log("订单查询参数="+JSON.stringify(this.queryParams))
      getReadingLogList(this.queryParams).then(response => {
        this.tableData = response.data.records;
        this.currentPage = response.data.current;
        this.pageSize = response.data.size;
        this.total = response.data.total;
      });
    },

    sourceList: function() {
      var sourceParams = {};
      sourceParams.pageSize = 1000;
      sourceParams.currentPage = 1;
      getSourceList(sourceParams).then(response => {
        this.sourceData.push(...response.data.records);
      });
    },

    handleFind: function() {
      this.currentPage = 1
      this.readingLogList();
    },


    /**
     * 翻页事件
     */
    handleSizeChange(val) {
      this.pageSize = val;
      this.readingLogList();
    },
    handleCurrentChange: function(val) {
      this.currentPage = val;
      this.readingLogList();
    },

    // 改变多选
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },

  }
};
</script>
<style scoped>
  .el-form-item {
    margin-bottom: 10px;
  }
</style>
